﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ChartGettingStarted
{
    public class ColumnSeriesExt : ColumnSeries
    {
        public override IList<ChartDataPoint> GetChartDataPoints()
        {
            if (ItemsSource == null) return null;
            IList<ChartDataPoint> chartDataPoints = new List<ChartDataPoint>();

            IEnumerator enumerator = ItemsSource.GetEnumerator();
            if (enumerator.MoveNext())
            {
                if (enumerator.Current is ExpandoObject)
                {
                    do
                    {
                        ExpandoObject item = enumerator.Current as ExpandoObject;
                        object xValue = null, yValue = null;

                        (item as IDictionary<string, object>).TryGetValue(XBindingPath, out xValue);
                        (item as IDictionary<string, object>).TryGetValue(YBindingPath, out yValue);
                        if (xValue != null && yValue != null)
                            chartDataPoints.Add(new ChartDataPoint((IComparable)xValue, Convert.ToDouble(yValue)));

                    } while (enumerator.MoveNext());
                }
                else
                {
                    return base.GetChartDataPoints();
                }
            }
            return chartDataPoints;
        }

    }
}
